/*********************************************************************

  ui_text.c

  Functions used to retrieve text used by MAME, to aid in
  translation.

*********************************************************************/

#include "driver.h"
#include "ui_text.h"

struct lang_struct lang;

char *trans_text[UI_last_entry + 1];

/* All entries in this table must match the enum ordering in "ui_text.h" */
const char * default_text[] =
{
#ifndef MESS
	"MAME",
#else
	"MESS",
#endif

	/* copyright stuff */
	"El uso de emuladores junto con ROMs que no posees est prohibido por las leyes de copyright.",
	"SI NO ESTAS LEGALMENTE AUTORIZADO PARA JUGAR \"%s\" EN ESTE EMULADOR, PULSA ESC.",
	"En caso contrario, teclea OK para continuar",

	/* misc stuff */
	"Volver al Menu Principal",
	"Volver al Menu Anterior",
	"Pulsa Una Tecla",
	"On",
	"Off",
	"ND",
	"OK",
	"NO VALIDO",
	"(nada)",
	"CPU",
	"Direccion",
	"Valor",
	"Sonido",
	"sonido",
	"estereo",
	"Juego Vectorial",
	"Resolucion de pantalla",
	"Texto",
	"Volumen",
	"Relativo",
	"TODOS LOS CANALES",
	"Brillo",
	"Gamma",
	"Parpadeo Vectores",
	"Intensidad Vectores",
	"Overclock",
	"TODAS LAS CPUS",
#ifndef MESS
	"Historial no disponible",
#else
	"Info de Sistema no disponible",
#endif

	/* special characters */
	"\x11",
	"\x10",
	"\x18",
	"\x19",
	"\x1a",
	"\x1b",

	/* known problems */
#ifndef MESS
	"Problemas conocidos de este juego:",
#else
	"Problemas conocidos de este sistema:",
#endif
	"La paleta de colores no esta 100% optimizada.",
	"La paleta de colores es totalmente erronea.",
	"El sistema de video no esta 100% optimizado.",
	"El sistema de sonido no esta 100% optimizado.",
	"El juego falla en el sonido.",
	"No soporta rotacion de pantalla en el modo cocktail.",
#ifndef MESS
	"ESTE JUEGO NO FUNCIONA CORRECTAMENTE",
#else
	"ESTE SISTEMA NO FUNCIONA CORRECTAMENTE",
#endif
	"El juego tiene un sistema de proteccion que no esta 100% emulado.",
	"Hay clones de este juego que SI funcionan. Estos son:",
	"Teclea OK para continuar",
#ifdef MESS
	"El sistema emulado es un ordenador: ",
	"La emulacin de teclado puede no ser 100% perfecta.",
	"Estado de la Emulacin del Teclado",
	"----------------------------------",
	"Modo: Emulacin PARCIAL",
	"Modo: Emulacin TOTAL",
	"IU:   Activada",
	"IU:   Desactivada",
	"**Usa ScrLock para cambiar**",
#endif

	/* main menu */
	"Entrada (general)",
	"Interruptores Dip",
	"Controles Analogicos",
	"Calibrar Joysticks",
	"Info de Biblioteca",
#ifndef MESS
	"Entrada (este juego)",
	"Informacion del juego",
	"Historial",
	"Reiniciar Juego",
	"Volver al Juego",
#else
	"Entrada (esta maquina)",
	"Informacion de la Maquina",
	"Uso e Historia de la Maquina",
	"Reiniciar Maquina",
	"Volver a la Maquina",
	"Informacion de Imagen",
	"Administrador de Ficheros",
	"Control de Cinta",

	"grabando",
	"cargando",
	"(grabando)",
	"(cargando)",
	"parado",
	"Pausa/Stop",
	"Grabar",
	"Cargar",
	"Rebobinar",
	"Avance Rapido",
	"Montar",
	"Desmontar",
	"[hueco vacio]",
	"Configuracion",
	"Salir de Selector",
	"Especificacion Fichero",   /* IMPORTANT: be careful to ensure that the following */
	"Cartucho",            /* device list matches the order found in device.h    */
	"Disquete",          /* and is ALWAYS placed after "File Specification"    */
	"Disco Duro",
	"Cilindro",
	"Cinta",
	"Tarjeta Interna",
	"Cinta Interna",
	"Impresora",
	"Puerto Serie",
	"Puerto Paralelo",
	"Volcado",
	"Carga Rapida",
#endif
	"Trucos",
	"Tarjeta de Memoria",

	/* input */
	"Velocidad Tec/Joy",
	"Reverso",
	"Sensibilidad",

	/* stats */
	"Tickets entregados",
	"Moneda",
	"(bloqueado)",

	/* memory card */
	"Cargar Tarjeta de Memoria",
	"Extraer Tarjeta de Memoria",
	"Crear Tarjeta de Memoria",
#ifdef MESS
	"Administrar Tarjeta de Memoria (RESET)",
#endif
	"Error al Cargar Tarjeta de Memoria!",
	"Cargada!",
	"Tarjeta de Memoria Extraida!",
	"Tarjeta de Memoria Creada!",
	"Error al Crear Tarjeta de Memoria!",
	"(Ya existe ?)",
	"OOPS!! Error Interno!",

	/* cheats */
	"Activar/Desactivar Truco",
	"Incluir/Editar Truco",
	"Nueva Busqueda de Truco",
	"Continuar Busqueda",
	"Ver Ultimos Resultados",
	"Restaurar Resultados Previos",
	"Configurar Watchpoints",
	"Ayuda General",
	"Opciones",
	"Recargar base de datos",
	"Watchpoint",
	"Desactivado",
	"Trucos",
	"Watchpoints",
	"Mas Info",
	"Mas Info para",
	"Nombre",
	"Descripcion",
	"Tecla de Activacion",
	"Codigo",
	"Max",
	"Fijar",
	"Conflicto encontrado en Truco: desactivando",
	"Ayuda aun no disponible",

	/* watchpoints */
	"Numero de bytes",
	"Tipo de Display",
	"Tipo de Etiqueta",
	"Etiqueta",
	"Posicion X",
	"Posicion Y",
	"Watch",

	"Hex",
	"Decimal",
	"Binary",

	/* searching */
	"Vidas (o cualquier otro valor)",
	"Temporizadores (+/- algun valor)",
	"Energia (mayor o menor)",
	"Estado (bits o flags)",
	"Lento pero seguro (cambiado o no)",
	"Cambiar Velocidad Busqueda",
	"Rapido",
	"Medio",
	"Lento",
	"Muy Lento",
	"Toda la Memoria",
	"Seleccionar Areas de Memoria",
	"Coincidencias Encontradas",
	"Busqueda no inicializada",
	"No hay valores previos",
	"Valores previos restaurados",
	"Restauracin completa",
	"Selecciona un valor",
	"Todos los valores grabados",
	"Coincidencia Encontrada - se anade a la lista",

	NULL
};

int uistring_init (mame_file *langfile)
{
	/*
		TODO: This routine needs to do several things:
			- load an external font if needed
			- determine the number of characters in the font
			- deal with multibyte languages

	*/

	int i;
	char curline[255];
	char section[255] = "\0";
	char *ptr;

	/* Clear out any default strings */
	for (i = 0; i <= UI_last_entry; i ++)
	{
		trans_text[i] = NULL;
	}

	memset(&lang, 0, sizeof(lang));

	if (!langfile) return 0;

	while (mame_fgets (curline, 255, langfile) != NULL)
	{
		/* Ignore commented and blank lines */
		if (curline[0] == ';') continue;
		if (curline[0] == '\n') continue;
            if (curline[0] == '\r') continue;

		if (curline[0] == '[')
		{
			ptr = strtok (&curline[1], "]");
			/* Found a section, indicate as such */
			strcpy (section, ptr);

			/* Skip to the next line */
			continue;
		}

		/* Parse the LangInfo section */
		if (strcmp (section, "LangInfo") == 0)
		{
			ptr = strtok (curline, "=");
			if (strcmp (ptr, "Version") == 0)
			{
				ptr = strtok (NULL, "\n\r");
				sscanf (ptr, "%d", &lang.version);
			}
			else if (strcmp (ptr, "Language") == 0)
			{
				ptr = strtok (NULL, "\n\r");
				strcpy (lang.langname, ptr);
			}
			else if (strcmp (ptr, "Author") == 0)
			{
				ptr = strtok (NULL, "\n\r");
				strcpy (lang.author, ptr);
			}
			else if (strcmp (ptr, "Font") == 0)
			{
				ptr = strtok (NULL, "\n\r");
				strcpy (lang.fontname, ptr);
			}
		}

		/* Parse the Strings section */
		if (strcmp (section, "Strings") == 0)
		{
			/* Get all text up to the first line ending */
			ptr = strtok (curline, "\n\r");

			/* Find a matching default string */
			for (i = 0; i < UI_last_entry; i ++)
			{
				if (strcmp (curline, default_text[i]) == 0)
				{
					char transline[255];

					/* Found a match, read next line as the translation */
					mame_fgets (transline, 255, langfile);

					/* Get all text up to the first line ending */
					ptr = strtok (transline, "\n\r");

					/* Allocate storage and copy the string */
					trans_text[i] = malloc (strlen(transline)+1);
					strcpy (trans_text[i], transline);

					/* Done searching */
					break;
				}
			}
		}
	}

	/* indicate success */
	return 0;
}

void uistring_shutdown (void)
{
	int i;

	/* Deallocate storage for the strings */
	for (i = 0; i <= UI_last_entry; i ++)
	{
		if (trans_text[i])
		{
			free (trans_text[i]);
			trans_text[i] = NULL;
		}
	}
}

const char * ui_getstring (int string_num)
{
	/* Try to use the language file strings first */
	if (trans_text[string_num] != NULL)
		return trans_text[string_num];
	else
		/* That failed, use the default strings */
		return default_text[string_num];
}
